



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Django数据库操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Django数据库操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:03:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<pre class="prettyprint linenums">刚学到Django的数据库操作，把它记录下来，方便以后查看：

在Django中定义数据库表，并使用Django提供的方法来对数据库进行操作（增、删、改、查）

<strong>1、定义3个数据库表：</strong></pre>
<div>
<pre class="prettyprint linenums"> class Group(models.Model):<br />
     name = models.CharField(max_length=50,default=None)

 class User(models.Model):<br />
     name = models.CharField(max_length=50,default=None)<br />
     Email = models.CharField(max_length=50,default=None)

     group_relation = models.ManyToManyField('Group',default=None)   #生成多对多表

 class Asset(models.Model):<br />
     hostname = models.CharField(max_length=50,default=None)<br />
     create_date = models.DateTimeField(auto_now_add=True)<br />
     update_date = models.DateTimeField(auto_now=True)</pre>
</div>
<pre class="prettyprint linenums"><strong><br />2、向数据库中添加内容<br /></strong></pre>
<div>
<pre class="prettyprint linenums"> Asset.objects.create(hostname=name)

 #多对多添加数据<br />
 u1 = User.objects.filter(id=1)<br />
 g1 = Group.objects.filter(id=1)<br />
 u1.group_relation.add(g1)<br />
 g1.user_set.add(u1)</pre>
</div>
<pre class="prettyprint linenums"><strong><br />3、从数据库中删除内容</strong></pre>
<div>
<pre class="prettyprint linenums">     Asset.objects.get(id=id).delete()

     # 多对多删除数据<br />
     u1 = User.objects.filter(id=1)<br />
     g1 = Group.objects.filter(id=1)<br />
     u1.group_relation.delete(g1)<br />
     g1.user_set.delete(u1)</pre>
</div>
<pre class="prettyprint linenums"><strong>4、修改数据库中的内容</strong></pre>
<div>
<pre class="prettyprint linenums">     #根据id修改hostname<br />
     obj = Asset.objects.get(id=id)<br />
     obj.hostname=hostname<br />
     obj.save()

     #所有id大于传入参数的，就将hostname修改<br />
     Asset.objects.filter(id__gt=id).update(hostname=hostname)</pre>
</div>
<pre class="prettyprint linenums"><strong>5、查询数据库中的内容</strong></pre>
<div>
<pre class="prettyprint linenums">     # 多对多获取数据<br />
     u1 = User.objects.filter(id=1)<br />
     g1 = Group.objects.filter(id=1)<br />
     u1.group_relation.all()<br />
     u1.group_relation.all().filter(id=1)<br />
     g1.user_set.all()<br />
     g1.user_set.all().filter(email='')

     #查找所有id大于传入参数的数据<br />
     Asset.objects.filter(id__gt=id)<br />
     #查找所有hostname包含传入参数的数据<br />
     Asset.objects.filter(hostname__contains=hostname)<br />
     #查找类型id等于5的所有用户信息---type__id:type表示UserInfo表中的type字段(对应type表的外键)，__id表示与userinfo表相关联的type表的id<br />
     UserIfo.objects.filter(type__id = 5)<br />
     #取出所有数据<br />
     Asset.objects.all()<br />
     #取出所有数据的前两条数据<br />
     Asset.objects.all()[0:2]<br />
     # 取出所有数据,并进行排序---id:按id正序排列，倒序就用'-id'<br />
     Asset.objects.all().order_by('id')<br />
     # 取出所有数据中的id和hostname列数据<br />
     Asset.objects.all().values('id','hostname')</pre>
</div>
<pre class="prettyprint linenums">
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqde71v9.html">分页型Memory LCD显存管理与emWin移植</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02kk0q.html">Asp&period;Net微信登录-电脑版扫描二维码登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmrgk19.html">CentOS 6&period;5上安装Python 2&period;7&period;9</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjo5gy8.html">vhost&period;sh 源代码，认真看哦</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj5on1q.html">搭建高可用mongo集群3&period;4版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kw3ez9.html">php将html转为图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwged78.html">postman接口自动化，环境变量的用法详解（附postman常用的方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wwkeq.html">python自动化开发-6-面向对象编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv27pex9.html">MySQL修改编码为UTF-8无效果解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w1z3gq.html">FCN-全卷积网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwv6kv9.html">js同时获得数组的两个最小值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10pgpq.html">jQuery实现省市联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r77x58.html">创建型模式篇（工厂模式Factory Pattern）</a>
		</li>
						<li><a href="https://www.batexi.com/a/953xo4z8.html">Pandas常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rndvx7q.html">javascript编写带阴历的黄历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjwdvjq.html">windows用户态程序的Dump</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o421zlq.html">SDOI2017硬币游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p1z43q.html">MVC学习之HtmlHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kl5w3q.html">form表单传递对象数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/95p35j6q.html">从零开始的Python学习Episode 6&mdash;&mdash;字符串操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1p4g59.html">（实用篇）php 文件夹删除，清除缓存程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yz5xjq.html">code&colon;&colon;blocks的快捷键汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdjyvy8.html">CSS基础知识点（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjd5ey9.html">使用npoi&period;dll导出数据到excel</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnkgpv8.html">DataTransfer&lpar;setData&lpar;&rpar;方法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zk6y49.html">leetcode 99  Recover Binary Search Tree ----- java</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mzryeq.html">urllib&comma;urllib2&comma;requests对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mzrkgq.html">黑马程序员&mdash;&mdash;JAVA基础之简述面向对象，类，变量，匿名对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdepn009.html">JAVA 线程池， 多线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnkpwv8.html">Windows Kernel Security Training Courses</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
